<h1 align="center">react-custom-scrollbar</h1>

<div align="center">

A React replacement for the browser's native scrollbar.

[![npm](https://img.shields.io/badge/npm-react--scroll--design-brightgreen.svg?style=flat-square)]()
[![npm version](https://img.shields.io/npm/v/react-scroll-design.svg?style=flat-square)](https://www.npmjs.com/package/react-scroll-design)
[![dumi](https://img.shields.io/badge/docs%20by-dumi-blue?style=flat-square)](https://github.com/umijs/dumi)

</div>

## Document

[English document](https://ddbor.github.io/react-scroll-design#/en-US) | [中文文档](https://ddbor.github.io/react-scroll-design/)

## Install

```bash
npm install react-scroll-design
```

```bash
yarn add react-scroll-design
```

```bash
pnpm add react-scroll-design
```

## Usage

This is the most basic way to use it, please check the [document](https://ddbor.github.io/react-scroll-design#/en-US) for more usage examples.

```jsx
import { ScrollContainer } from 'react-scroll-design';

export default () => (
  <ScrollContainer height={400}>
    {/* Simply replace the content with your own. */}
    {new Array(20).fill(1).map((item, index) => {
      return (
        <div key={index} className="example-scrollbar-demo-item">
          {index + 1}
        </div>
      );
    })}
  </ScrollContainer>
);
```
