function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useEffect, useMemo, useRef, useState } from 'react';
import { useDocumentSelectStart } from "../hooks";
import { calculateRatio, clamp, getDomRect, getRatio, isNumber } from "./util";
export var CustomBar = function CustomBar(_ref) {
  var direction = _ref.direction,
    onChange = _ref.onChange,
    ratio = _ref.ratio,
    _ref$shouldScroll = _ref.shouldScroll,
    shouldScroll = _ref$shouldScroll === void 0 ? false : _ref$shouldScroll,
    always = _ref.always,
    _ref$barStyle = _ref.barStyle,
    barStyle = _ref$barStyle === void 0 ? {} : _ref$barStyle,
    _ref$barClassName = _ref.barClassName,
    barClassName = _ref$barClassName === void 0 ? '' : _ref$barClassName,
    barNode = _ref.barNode;
  var trackRef = useRef(null);
  var thumbRef = useRef(null);
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    state = _useState2[0],
    setState = _useState2[1];
  var isVertical = useMemo(function () {
    return direction === 'vertical';
  }, [direction]);
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    isMouseMove = _useState4[0],
    setIsMouseMove = _useState4[1];
  var _useState5 = useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    isMouseDown = _useState6[0],
    setIsMouseDown = _useState6[1];
  // 轨道
  var _useMemo = useMemo(function () {
      var rect = getDomRect(trackRef.current);
      var trackSize = isVertical ? rect.height : rect.width;
      return {
        trackSize: trackSize
      };
    }, [trackRef.current, isVertical, ratio]),
    trackSize = _useMemo.trackSize;
  // 条
  var _useMemo2 = useMemo(function () {
      var rect = getDomRect(thumbRef.current);
      var thumbSize = isVertical ? rect.height : rect.width;
      return {
        thumbSize: thumbSize
      };
    }, [thumbRef.current, isVertical, ratio]),
    thumbSize = _useMemo2.thumbSize;
  var _useDocumentSelectSta = useDocumentSelectStart(),
    setOnselectstart = _useDocumentSelectSta.setOnselectstart,
    restoreOnselectstart = _useDocumentSelectSta.restoreOnselectstart;
  var realThumbRatio = 0; // 通过这个变量记录Move时的实时位置
  var initThumbOffsetSize = 0;
  var trackClassName = useMemo(function () {
    return "rsd-track rsd-track-".concat(direction, " ").concat(!shouldScroll ? '' : 'rsd-track-' + (always || isMouseMove ? 'always-' : 'should-') + direction);
  }, [direction, shouldScroll, isMouseMove, always]);
  var thumbStyle = useMemo(function () {
    return isVertical ? _objectSpread(_objectSpread({
      height: '30%'
    }, barStyle), {}, {
      transform: "translateY(".concat(state, "%)")
    }) : _objectSpread(_objectSpread({
      width: '12%'
    }, barStyle), {}, {
      transform: "translateX(".concat(state, "%)")
    });
  }, [isVertical, state]);
  var getTrackOffset = function getTrackOffset() {
    var rect = getDomRect(trackRef.current);
    return isVertical ? rect.top : rect.left;
  };
  var getClient = function getClient(e) {
    return isVertical ? e.clientY : e.clientX;
  };
  var getClientDistance = function getClientDistance(e) {
    var trackOffset = getTrackOffset();
    return Math.abs(getClient(e) - trackOffset);
  };
  var handleDocumentMouseMove = function handleDocumentMouseMove(e) {
    if (getClient(e) < getTrackOffset()) {
      return;
    }
    var offset = getClientDistance(e) - initThumbOffsetSize;
    var trackThumbSizeRatio = getRatio(trackSize - thumbSize, thumbSize);
    var contentRatio = clamp(getRatio(offset, trackSize - initThumbOffsetSize - (thumbSize - initThumbOffsetSize)), 0, 100);
    onChange(contentRatio);
    var newSaveState = clamp(getRatio(offset, thumbSize), 0, trackThumbSizeRatio);
    realThumbRatio = newSaveState;
    setState(realThumbRatio);
  };
  var handleDocumentMouseUp = function handleDocumentMouseUp() {
    setIsMouseMove(false);
    document.removeEventListener('mousemove', handleDocumentMouseMove);
    document.removeEventListener('mouseup', handleDocumentMouseUp);
    restoreOnselectstart();
  };
  var handleClickThumb = function handleClickThumb(e) {
    e.stopPropagation();
    setIsMouseMove(true);
    realThumbRatio = state;
    initThumbOffsetSize = getClientDistance(e) - thumbSize * (state / 100);
    document.addEventListener('mousemove', handleDocumentMouseMove);
    document.addEventListener('mouseup', handleDocumentMouseUp);
    setOnselectstart(function () {
      return false;
    });
  };
  var updateThumbPosition = function updateThumbPosition() {
    var offsetParent = (trackSize - thumbSize) * (ratio / 100);
    var val = getRatio(offsetParent, thumbSize);
    setState(val); // 滚动条
  };

  var handleTrackClick = function handleTrackClick(e) {
    setIsMouseDown(true);
    var offsetParent = getClientDistance(e);
    var halfSize = thumbSize / 2;
    if (offsetParent - thumbSize <= 0) {
      setState(0);
      onChange(0);
      return;
    }
    var _calculateRatio = calculateRatio(offsetParent, halfSize, trackSize, thumbSize),
      thumbRatio = _calculateRatio.ratio,
      viewRatio = _calculateRatio.viewRatio;
    setState(thumbRatio);
    onChange(viewRatio);
  };
  useEffect(function () {
    if (!isMouseMove && !isMouseDown && isNumber(ratio)) {
      updateThumbPosition();
    }
    if (isMouseDown) {
      setIsMouseDown(false);
    }
  }, [ratio]);
  return /*#__PURE__*/React.createElement("div", {
    ref: trackRef,
    className: trackClassName,
    onMouseDown: handleTrackClick
  }, /*#__PURE__*/React.createElement("div", {
    ref: thumbRef,
    className: "rsd-thumb ".concat(barClassName),
    style: thumbStyle,
    onMouseDown: handleClickThumb
  }, barNode));
};