function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["tag", "className", "style", "viewTag", "viewClassName", "viewStyle", "children", "native", "always", "height", "maxHeight", "noresize", "ratio", "xBarStyle", "yBarStyle", "xBarClassName", "yBarClassName", "xBarNode", "yBarNode", "onScroll"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { Children, useEffect, useRef } from 'react';
import { useScrollContainer } from "../hooks";
import { CustomBar } from "./CustomBar";
import "./index.css";
export var ScrollContainer = function ScrollContainer(_ref) {
  var _ref$tag = _ref.tag,
    tag = _ref$tag === void 0 ? 'div' : _ref$tag,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? '' : _ref$className,
    style = _ref.style,
    _ref$viewTag = _ref.viewTag,
    viewTag = _ref$viewTag === void 0 ? 'div' : _ref$viewTag,
    _ref$viewClassName = _ref.viewClassName,
    viewClassName = _ref$viewClassName === void 0 ? '' : _ref$viewClassName,
    viewStyle = _ref.viewStyle,
    children = _ref.children,
    _ref$native = _ref.native,
    native = _ref$native === void 0 ? false : _ref$native,
    _ref$always = _ref.always,
    always = _ref$always === void 0 ? true : _ref$always,
    height = _ref.height,
    maxHeight = _ref.maxHeight,
    _ref$noresize = _ref.noresize,
    noresize = _ref$noresize === void 0 ? false : _ref$noresize,
    ratio = _ref.ratio,
    xBarStyle = _ref.xBarStyle,
    yBarStyle = _ref.yBarStyle,
    xBarClassName = _ref.xBarClassName,
    yBarClassName = _ref.yBarClassName,
    xBarNode = _ref.xBarNode,
    yBarNode = _ref.yBarNode,
    onScroll = _ref.onScroll,
    htmlType = _objectWithoutProperties(_ref, _excluded);
  var targetRef = useRef(null); // 包裹内容的元素
  var viewRef = useRef(null); // 视图元素
  var _useScrollContainer = useScrollContainer({
      target: targetRef,
      view: viewRef,
      noresize: noresize
    }),
    position = _useScrollContainer.position,
    shouldScrollX = _useScrollContainer.shouldScrollX,
    shouldScrollY = _useScrollContainer.shouldScrollY,
    setScrollX = _useScrollContainer.setScrollX,
    setScrollY = _useScrollContainer.setScrollY,
    ratioX = _useScrollContainer.ratioX,
    ratioY = _useScrollContainer.ratioY;
  useEffect(function () {
    if (!ratio) {
      return;
    }
    if (shouldScrollX) {
      setScrollX(ratio.x);
    }
    if (shouldScrollY) {
      setScrollY(ratio.y);
    }
  }, [ratio]);
  useEffect(function () {
    if (onScroll) {
      var res = {
        x: ratioX,
        y: ratioY
      };
      onScroll(res, position || {
        left: 0,
        top: 0
      });
    }
  }, [ratioY, ratioX]);
  return /*#__PURE__*/React.createElement(tag, _objectSpread({
    className: "rsd ".concat(className),
    style: style
  }, htmlType),
  /*#__PURE__*/
  // 内容包裹
  React.createElement('div', {
    className: "rsd-wrap ".concat(native ? '' : 'rsd-wrap-hidden'),
    style: {
      height: height,
      maxHeight: maxHeight
    },
    ref: targetRef
  },
  /*#__PURE__*/
  // 视图
  React.createElement(viewTag, {
    style: viewStyle,
    className: viewClassName,
    ref: viewRef
  }, Children.toArray(children))), !native ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(CustomBar, {
    direction: "horizontal",
    always: always,
    shouldScroll: shouldScrollX,
    ratio: ratioX,
    barStyle: xBarStyle,
    barClassName: xBarClassName,
    barNode: xBarNode,
    onChange: setScrollX
  }), /*#__PURE__*/React.createElement(CustomBar, {
    direction: "vertical",
    always: always,
    shouldScroll: shouldScrollY,
    ratio: ratioY,
    barStyle: yBarStyle,
    barClassName: yBarClassName,
    barNode: yBarNode,
    onChange: setScrollY
  })) : null);
};