export var isNumber = function isNumber(num) {
  return typeof num === 'number';
};
export var getRatio = function getRatio(mol, den) {
  if (!mol) {
    return 0;
  }
  if (!den) {
    return 100;
  }
  return Math.round(mol / den * 1000000) / 10000;
};
export var clamp = function clamp(value, min, max) {
  return Math.min(Math.max(value, min), max);
};
export var calculateRatio = function calculateRatio(offsetParent, halfSize, trackSize, thumbSize) {
  var ratio = 0;
  var viewRatio = 0;
  if (offsetParent >= trackSize - halfSize) {
    ratio = getRatio(trackSize - thumbSize, thumbSize);
    viewRatio = 100;
  } else {
    var offset = offsetParent - halfSize;
    ratio = getRatio(offset, thumbSize);
    viewRatio = getRatio(offsetParent, trackSize);
  }
  return {
    ratio: ratio,
    viewRatio: viewRatio
  };
};
export var getDomRect = function getDomRect(dom) {
  return (dom === null || dom === void 0 ? void 0 : dom.getBoundingClientRect()) || {
    top: 0,
    left: 0,
    width: 0,
    height: 0
  };
};
export var getSizeValues = function getSizeValues(element) {
  if (!element) {
    return {
      scrollHeight: 0,
      clientHeight: 0,
      scrollWidth: 0,
      clientWidth: 0
    };
  }
  var scrollHeight = element.scrollHeight,
    clientHeight = element.clientHeight,
    scrollWidth = element.scrollWidth,
    clientWidth = element.clientWidth;
  return {
    scrollHeight: scrollHeight,
    clientHeight: clientHeight,
    scrollWidth: scrollWidth,
    clientWidth: clientWidth
  };
};