import { useEffect, useRef } from 'react';
function useDocumentSelectStart() {
  var originalOnSelectStart = useRef(null);
  var restoreOnselectstart = function restoreOnselectstart() {
    if (document.onselectstart !== originalOnSelectStart.current) {
      document.onselectstart = originalOnSelectStart.current;
    }
  };
  var setOnselectstart = function setOnselectstart(fn) {
    originalOnSelectStart.current = document.onselectstart;
    document.onselectstart = fn;
  };
  useEffect(function () {
    return function () {
      restoreOnselectstart();
    };
  }, []);
  return {
    setOnselectstart: setOnselectstart,
    restoreOnselectstart: restoreOnselectstart
  };
}
export default useDocumentSelectStart;