/// <reference types="react" />
export declare type Target = React.RefObject<any>;
declare type Props = {
    target: Target;
    view: Target;
    noresize: boolean;
};
/**
 * @param target 包裹内容的元素，主要作用是产生滚动
 * @param view 包裹视图的元素，主要监听宽高变化，控制滚动条显示隐藏
 * @returns
 */
declare function useScrollContainer({ target, view, noresize }: Props): {
    position: import("..").Position | undefined;
    setScrollY: (val: number) => void;
    setScrollX: (val: number) => void;
    shouldScrollX: boolean;
    shouldScrollY: boolean;
    ratioX: number;
    ratioY: number;
};
export default useScrollContainer;
