function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useEffect, useMemo, useState } from 'react';
import { useScroll, useSize } from '.';
import { getRatio, getSizeValues } from "../ScrollContainer/util";
/**
 * @param target 包裹内容的元素，主要作用是产生滚动
 * @param view 包裹视图的元素，主要监听宽高变化，控制滚动条显示隐藏
 * @returns
 */
function useScrollContainer(_ref) {
  var target = _ref.target,
    view = _ref.view,
    noresize = _ref.noresize;
  // 滚动位置
  var position = useScroll(target);
  // 包裹元素宽高
  var targetSize = useSize(target, noresize);
  // view区域宽高
  var viewSize = useSize(view, noresize);
  var _useState = useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    targetEl = _useState2[0],
    setTargetEl = _useState2[1];
  var _useMemo = useMemo(function () {
      if (!targetEl) {
        return [false, false];
      }
      var _getSizeValues = getSizeValues(targetEl),
        scrollHeight = _getSizeValues.scrollHeight,
        clientHeight = _getSizeValues.clientHeight,
        scrollWidth = _getSizeValues.scrollWidth,
        clientWidth = _getSizeValues.clientWidth;
      return [scrollHeight > clientHeight, scrollWidth > clientWidth];
    }, [targetEl, viewSize, targetSize]),
    _useMemo2 = _slicedToArray(_useMemo, 2),
    shouldScrollY = _useMemo2[0],
    shouldScrollX = _useMemo2[1];
  var _useMemo3 = useMemo(function () {
      if (!targetEl) {
        return [0, 0];
      }
      var _getSizeValues2 = getSizeValues(targetEl),
        scrollHeight = _getSizeValues2.scrollHeight,
        clientHeight = _getSizeValues2.clientHeight,
        scrollWidth = _getSizeValues2.scrollWidth,
        clientWidth = _getSizeValues2.clientWidth;
      return [scrollHeight - clientHeight, scrollWidth - clientWidth];
    }, [targetEl, viewSize, targetSize]),
    _useMemo4 = _slicedToArray(_useMemo3, 2),
    scrollableYArea = _useMemo4[0],
    scrollableXArea = _useMemo4[1];
  var ratioY = useMemo(function () {
    if (!position) {
      return 0;
    }
    return getRatio(position.top, scrollableYArea);
  }, [position === null || position === void 0 ? void 0 : position.top, scrollableYArea]);
  var ratioX = useMemo(function () {
    if (!position) {
      return 0;
    }
    return getRatio(position.left, scrollableXArea);
  }, [position === null || position === void 0 ? void 0 : position.left, scrollableXArea]);
  var setScrollY = function setScrollY(val) {
    if (targetEl) targetEl.scrollTop = scrollableYArea * (val / 100);
  };
  var setScrollX = function setScrollX(val) {
    if (targetEl) targetEl.scrollLeft = scrollableXArea * (val / 100);
  };
  useEffect(function () {
    var el = target.current;
    setTargetEl(el);
  }, [target]);
  return {
    position: position,
    // 内容滚动位置
    setScrollY: setScrollY,
    // 设置内容滚动位置
    setScrollX: setScrollX,
    // 设置内容滚动位置
    shouldScrollX: shouldScrollX,
    // 是否应该有滚动
    shouldScrollY: shouldScrollY,
    // 是否应该有滚动
    ratioX: ratioX,
    // 内容滚动比率
    ratioY: ratioY // 内容滚动比率
  };
}

export default useScrollContainer;